c_EnemyRange=200
c_EnemyFOV=math.pi

Enemies={
	{x=120,y=200,i=0,j=1,Apt=1,Bpt=4,pts={},alt=false,disp={ani=1,frm=1}}
}

for i=1,5 do
	table.insert(Enemies, {x=math.random(500),y=math.random(500),i=0,j=1, Apt=1,Bpt=4,pts={},alt=false,disp={ani=1,frm=1}})
end
 
function DrawEnemy()
	for e=1,table.getn(Enemies) do
		if math.abs(Enemies[e].i) > Enemies[e].j then  
			if Enemies[e].i > 0 then Enemies[e].disp.ani=4
			else  Enemies[e].disp.ani=3 end
		else
			if Enemies[e].j > 0 then Enemies[e].disp.ani=2
			else Enemies[e].disp.ani=1 end
		end
		
		if not Enemies[e].alt then Enemies[e].disp.frm=Enemies[e].disp.frm+0.1 end		
		if not Player.disp.quad[Enemies[e].disp.ani][math.floor(Enemies[e].disp.frm)] or Enemies[e].alt then Enemies[e].disp.frm=1 end
		
		if e > 1 and math.abs(Enemies[e].x-Enemies[e-1].x) < 16 and math.abs(Enemies[e].y-Enemies[e-1].y) <= 2 then Enemies[e].y=Enemies[e].y+(Enemies[e].y-Enemies[e-1].y)/2; Enemies[e-1].y=Enemies[e-1].y-(Enemies[e].y-Enemies[e-1].y)/2 end
		love.graphics.drawq( Player.disp.img,  Player.disp.quad[Enemies[e].disp.ani][math.floor(Enemies[e].disp.frm)], Enemies[e].x-Player.w/2-Offset.x, Enemies[e].y-Player.h-Offset.y)
		--love.graphics.line(Enemies[e].x-Offset.x,Enemies[e].y-Offset.y,Enemies[e].x+Enemies[e].i*10-Offset.x,Enemies[e].y+Enemies[e].j*10-Offset.y)
	end
end

function EnemyShoot()
	for e=1,table.getn(Enemies) do
		if Enemies[e].alt then table.insert(Bullets.enemies, {x=Enemies[e].x+Enemies[e].i*24,y=Enemies[e].y+Enemies[e].j*24-8,i=Enemies[e].i,j=Enemies[e].j,m=10}) end
	end
end

function MoveEnemyToPoint()
	local mag
	
	for e=1,table.getn(Enemies) do
		if Enemies[e].pts[1] then				
			Enemies[e].i,Enemies[e].j,mag=UnitVector(Enemies[e].pts[table.getn(Enemies[e].pts)].x-Enemies[e].x,Enemies[e].pts[table.getn(Enemies[e].pts)].y-Enemies[e].y)
			if not Enemies[e].alt then		
				if mag < 1 then
					Enemies[e].i,Enemies[e].j = Enemies[e].i*mag,Enemies[e].j*mag
				end
				Enemies[e].x,Enemies[e].y=Enemies[e].x+Enemies[e].i,Enemies[e].y+Enemies[e].j
			end
			if Enemies[e].x==Enemies[e].pts[table.getn(Enemies[e].pts)].x and Enemies[e].y==Enemies[e].pts[table.getn(Enemies[e].pts)].y then Enemies[e].pts[table.getn(Enemies[e].pts)] = nil end
		else
			Enemies[e].i,Enemies[e].j,mag=UnitVector(WayPoints[Enemies[e].Bpt].x-Enemies[e].x,WayPoints[Enemies[e].Bpt].y-Enemies[e].y)	

			if mag < 1 then
				Enemies[e].i,Enemies[e].j = Enemies[e].i*mag,Enemies[e].j*mag
			end			
			Enemies[e].x,Enemies[e].y=Enemies[e].x+Enemies[e].i,Enemies[e].y+Enemies[e].j
			
			if Enemies[e].x==WayPoints[Enemies[e].Bpt].x and Enemies[e].y==WayPoints[Enemies[e].Bpt].y then
				From=Enemies[e].Apt
				Enemies[e].Apt=Enemies[e].Bpt
				while true do
					Enemies[e].Bpt=WayPoints[Enemies[e].Apt].con[math.random(1,table.getn(WayPoints[Enemies[e].Apt].con))]
					if Enemies[e].Bpt~=From then break end
				end
			end
		end
		
		table.sort(Enemies, ZOrder)
	end
end

function CheckSighted()
	local Spotted, Diri,Dirj,Dirm
	
	for e=1,table.getn(Enemies) do
		--Checks If Player is in Enemy Eyesight Range
		if (Player.x-Enemies[e].x)^2+(Player.y-Enemies[e].y)^2 <= c_EnemyRange^2 then			
			Diri,Dirj,Dirm=UnitVector(Player.x-Enemies[e].x,Player.y-Enemies[e].y)
			if math.abs(math.acos(DotProduct(Enemies[e].i,Enemies[e].j, Diri,Dirj))) <= c_EnemyFOV/2 then
				Spotted=true
				if RayTrace(Enemies[e].x-8,Enemies[e].y,Diri,Dirj,Dirm)
				or RayTrace(Enemies[e].x+8,Enemies[e].y,Diri,Dirj,Dirm)
				or RayTrace(Enemies[e].x-8,Enemies[e].y-12,Diri,Dirj,Dirm)
				or RayTrace(Enemies[e].x+8,Enemies[e].y-12,Diri,Dirj,Dirm) then Spotted=false end
				
				--[[Spotted=true
				--Ray Tracing backwards from player to enemy
				while Spotted and Dirm > 0 do
					if Map[RetTile(Enemies[e].y+Dirj*Dirm)][RetTile(Enemies[e].x-8+Diri*Dirm)] ~= 240 
					or Map[RetTile(Enemies[e].y-24+Dirj*Dirm)][RetTile(Enemies[e].x-8+Diri*Dirm)] ~= 240 
					or Map[RetTile(Enemies[e].y-24+Dirj*Dirm)][RetTile(Enemies[e].x+8+Diri*Dirm)] ~= 240 
					or Map[RetTile(Enemies[e].y+Dirj*Dirm)][RetTile(Enemies[e].x+8+Diri*Dirm)] ~= 240 then Spotted=false end
					Dirm=Dirm-c_TileSize
				end]]
			end
			
		end
		if Spotted then
			if table.getn(Enemies[e].pts) ==0 then
				table.insert(Enemies[e].pts,{x=Enemies[e].x,y=Enemies[e].y})
			end
			if not Enemies[e].alt then
				--if (Enemies[e].pts[table.getn(Enemies[e].pts)-1].x-Enemies[e].pts[table.getn(Enemies[e].pts)-2].x)^2+(Enemies[e].pts[table.getn(Enemies[e].pts)-1].y-Enemies[e].pts[table.getn(Enemies[e].pts)-2].y)^2 > 16^2 then
				table.insert(Enemies[e].pts,{x=Player.x,y=Player.y})			
				Enemies[e].pts[table.getn(Enemies[e].pts)-1]={x=Enemies[e].x,y=Enemies[e].y}
				Enemies[e].alt=true
			else
				Enemies[e].pts[table.getn(Enemies[e].pts)]={x=Player.x,y=Player.y}
			end
			Spotted=false
		else
			Enemies[e].alt=false
		end
	end
end